#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h> // WatchDog          
#include <stdint.h>
#include <string.h>

#include "Ethernet/socket.h"
#include "Ethernet/wizchip_conf.h"

#include "Internet/MQTT/mqtt_interface.h"
#include "Internet/MQTT/MQTTClient.h"

#include "avrIOhelper/io-helper.h"
#include "millis.h"
#include "uart.h"
#include "spi.h"
#include "mqtt.h"
#include "temperature.h"
#include "modbus-master.h"
#include "gefran_gtf.h"
#include "pumpe.h"
#include "heizung.h"

#include "util/delay.h"

Client mqtt_client;

//***********Prologue for fast WDT disable & and save reason of reset/power-up: BEGIN
uint8_t mcucsr_mirror __attribute__ ((section (".noinit")));

// This is for fast WDT disable & and save reason of reset/power-up
void get_mcusr(void) \
         __attribute__((naked)) \
         __attribute__((section(".init3")));
void get_mcusr(void)
{
    mcucsr_mirror = MCUSR;
    MCUSR = 0;
    wdt_disable();
}
//***********Prologue for fast WDT disable & and save reason of reset/power-up: END


//FUNC headers
static void avr_init(void);
void timer0_init(void);
void print_network_information(void);

void IO_LIBRARY_Init(void) {
    uint8_t bufSize[] = {2, 2, 2, 2, 2, 2, 2, 2};

    reg_wizchip_cs_cbfunc(spi_select, spi_deselect);
    reg_wizchip_spi_cbfunc(spi_read, spi_write);
    //reg_wizchip_spiburst_cbfunc(spi_rb_burst, spi_wb_burst);

    wizchip_init(bufSize, bufSize);
    wizchip_setnetinfo(&netInfo);
    //wizchip_setinterruptmask(IK_SOCK_0);
}

void do_notaus(){
    if(read_Input(IN_NOTAUS_ANLAGE, LEVEL) || read_Input(IN_NOTAUS_SCHRANK, LEVEL) || read_Input(IN_NOTAUS_ANLAGE_KALT, LEVEL)){
        /* at least one pressed */
        //notaus_state = POWER_OFF;

        set_Output(LED_GRN_NOTAUS_SCHRANK,   OFF);
        set_Output(LED_GRN_NOTAUS_ANLAGE,    OFF);
        set_Output(LED_GRN_NOTAUS_ANLAGE_KALT,   OFF);

        if(read_Input(IN_NOTAUS_ANLAGE, LEVEL)){
            set_Output(LED_ROT_NOTAUS_ANLAGE, BLINK);
            set_Output(LED_ROT_NOTAUS_SCHRANK,   ON);
            set_Output(LED_ROT_NOTAUS_ANLAGE_KALT,   ON);
        }

        if(read_Input(IN_NOTAUS_SCHRANK, LEVEL)){
            set_Output(LED_ROT_NOTAUS_ANLAGE,    ON);
            set_Output(LED_ROT_NOTAUS_SCHRANK, BLINK);
            set_Output(LED_ROT_NOTAUS_ANLAGE_KALT,   ON);
        }

        if(read_Input(IN_NOTAUS_ANLAGE_KALT, LEVEL)){
            set_Output(LED_ROT_NOTAUS_ANLAGE,    ON);
            set_Output(LED_ROT_NOTAUS_SCHRANK,   ON);
            set_Output(LED_ROT_NOTAUS_ANLAGE_KALT, BLINK);
        }

    }
    else if(read_Input(IN_ANLAGE_EIN_INV, LEVEL)){
        /* nothing pressed, but power not on */
        //notaus_state = ARMED;

        set_Output(LED_ROT_NOTAUS_ANLAGE,  ON);
        set_Output(LED_ROT_NOTAUS_SCHRANK, ON);
        set_Output(LED_ROT_NOTAUS_ANLAGE_KALT, ON);

        set_Output(LED_GRN_NOTAUS_SCHRANK, ON);
        set_Output(LED_GRN_NOTAUS_ANLAGE,  ON);
        set_Output(LED_GRN_NOTAUS_ANLAGE_KALT, ON);
    }
    else{
        /* powered on */
        //notaus_state = POWER_ON;

        set_Output(LED_GRN_NOTAUS_SCHRANK,   ON);
        set_Output(LED_GRN_NOTAUS_ANLAGE,    ON);
        set_Output(LED_GRN_NOTAUS_ANLAGE_KALT,   ON);

        set_Output(LED_ROT_NOTAUS_ANLAGE,    OFF);
        set_Output(LED_ROT_NOTAUS_SCHRANK,   OFF);
        set_Output(LED_ROT_NOTAUS_ANLAGE_KALT,   OFF);
    }

}

void send_temperatures(void){
    for(uint8_t i=0; i<sizeof(ADC_reading)/sizeof(ADC_reading[0]);i++){
        char tpc[64];
        sprintf(tpc, "/Filamentanlage/02_Wasserbecken/state/temp%d", i);
        send_value_fl(&mqtt_client, tpc, ADC_reading[i], 1);
    }

}

int main()
{
    // INIT MCU
    avr_init();
    spi_init(); //SPI Master, MODE0, 4Mhz(DIV4), CS_PB.3=HIGH - suitable for WIZNET 5x00(1/2/5)
    //spi_speed_tst(); / Here on SPI pins: MOSI 400Khz freq out, on SCLK 3.2MhzOUT (Witk SPI CLK 4Mhz)

    ioHelperInitBuffer();
    ioHelperIoConf();

    //Wizchip WIZ5500 Ethernet initialize
    IO_LIBRARY_Init(); //After that ping must working
    print_network_information();

#if PLC_MQTT_ENABLED
    //****************MQTT client initialize
    //Find MQTT broker and connect with it
    uint8_t mqtt_buf[100];
    int32_t mqtt_rc = 0;
    Network mqtt_network;
    mqtt_network.my_socket = SOCK_MQTT;

    printf(">>Trying connect to MQTT broker: %d.%d.%d.%d ..\r\n", MQTT_targetIP[0], MQTT_targetIP[1], MQTT_targetIP[2], MQTT_targetIP[3]);
    NewNetwork(&mqtt_network);
    ConnectNetwork(&mqtt_network, MQTT_targetIP, 1883);
    MQTTClient(&mqtt_client, &mqtt_network, 1000, mqtt_buf, 100, mqtt_readBuffer, MQTT_BUFFER_SIZE);

    //Connection to MQTT broker
    MQTTPacket_connectData data = MQTTPacket_connectData_initializer;
    data.willFlag = 0;
    data.MQTTVersion = 4;//3;
    data.clientID.cstring = (char*)"controllino_wasserbecken";
    data.username.cstring = (char*)"Wasserbecken";
    data.password.cstring = (char*)"\0";
    data.keepAliveInterval = 10;
    data.cleansession = 1;
    mqtt_rc = MQTTConnect(&mqtt_client, &data);
    if (mqtt_rc == SUCCESSS)
    {
        printf("++MQTT Connected SUCCESS: %ld\r\n", mqtt_rc);
    }
    else
    {
        printf("--MQTT Connected ERROR: %ld\r\n", mqtt_rc);
        while(1); //Reboot the board
    }
#endif

    set_Output(LED_PLC_OK, BLINK);

    uint32_t timer_blink_outs = millis();
    uint32_t timer_send_uptime = millis();
    uint32_t timer_send_temps = millis();
    uint32_t timer_gtf_comm = millis();

    send_value(&mqtt_client, "/Filamentanlage/02_Wasserbecken/connected", 1);
    send_value(&mqtt_client, "/Filamentanlage/02_Wasserbecken/state/pumpe_warm", 0);
    send_value(&mqtt_client, "/Filamentanlage/02_Wasserbecken/state/heizung", 0);
    send_value_fl(&mqtt_client, "/Filamentanlage/02_Wasserbecken/state/heizung_sp", heizung_setpoint, 0);

    gtf_init(5);
    gtf_init(6);
    gtf_init(7);

    while(1)
    {
        wdt_reset(); // WDT reset at least every sec

        ioHelperReadPins();
        ioHelperDebounce();
        ioHelperEdgeDetector();
        
        // Toggle all outs which are set to blinking
        if(millis() - timer_blink_outs > 500){
            timer_blink_outs = millis();
            outStates[0] ^= outStatesBlinking[0];
            outStates[1] ^= outStatesBlinking[1];
            outStates[2] ^= outStatesBlinking[2];
            outStates[3] ^= outStatesBlinking[3];
        }

        if(millis() - timer_send_temps > 5000){
            timer_send_temps = millis();
            send_temperatures();

            //send_value(&mqtt_client, "/Filamentanlage/02_Wasserbecken/state/gtf5_power", gtf_read_register(5, GTF_POWER));

            if(read_Input(IN_KLATWASSER_DRAN, LEVEL)){
                send_value(&mqtt_client, "/Filamentanlage/03_Wasserbecken/state/connected", 1);
                set_Output(LED_KALTWASSER_DRAN_GR, 1);
                set_Output(LED_KALTWASSER_DRAN_RT, 0);
            }
            else{
                send_value(&mqtt_client, "/Filamentanlage/03_Wasserbecken/state/connected", 0);
                set_Output(LED_KALTWASSER_DRAN_GR, 0);
                set_Output(LED_KALTWASSER_DRAN_RT, 1);
            }
        }

        if(millis() - timer_gtf_comm > 200){
            timer_gtf_comm = millis();
            comm_heizung();
        }

        // send misc info
        if(millis() - timer_send_uptime > 5000){
            timer_send_uptime = millis();
            send_value(&mqtt_client, "/Filamentanlage/02_Wasserbecken/uptime", millis()/1000);
        }

        do_pumpe();
        do_notaus();
        do_heizung();

        ioHelperSetBit(outStates, LED_BUS_OK, 1);
        ioHelperSetOuts();
#if PLC_MQTT_ENABLED
        MQTTYield(&mqtt_client, 10); //blocking call
#else
        _delay_ms(1);
#endif
        ioHelperSetBit(outStates, LED_BUS_OK, 0);
        ioHelperSetOuts();
    }
    return 0;
}

// Timer0
// 1ms IRQ
// Used for millis() timing
void timer0_init(void)
{
    TCCR0A = (1<<WGM01); //TIMER0 SET-UP: CTC MODE
    TCCR0B = (1<<CS01)|(1<<CS00); // PS 1:64
    OCR0A = 249; // 1ms reach for clear (16mz:64=>250kHz:250-=>1kHz)
    TIMSK0 |= 1<<OCIE0A;	 //IRQ on TIMER0 output compareA
}

static void avr_init(void)
{
    // Initialize device here.
    // WatchDog INIT
    wdt_enable(WDTO_2S);  // set up wdt reset interval 2 second
    wdt_reset(); // wdt reset ~ every <2000ms

    timer0_init();// Timer0 millis engine init
    uart_init();
    initADC();

    modbus_master_init();

    sei(); //re-enable global interrupts

    return;
}

void print_network_information(void)
{

    uint8_t tmpstr[6] = {0,};
    ctlwizchip(CW_GET_ID,(void*)tmpstr); // Get WIZCHIP name
    printf("\r\n=======================================\r\n");
    printf(" WIZnet chip:  %s \r\n", tmpstr);
    printf("=======================================\r\n");

    wiz_NetInfo gWIZNETINFO;
    wizchip_getnetinfo(&gWIZNETINFO);
    if (gWIZNETINFO.dhcp == NETINFO_STATIC)
        printf("STATIC IP\r\n");
    else
        printf("DHCP IP\r\n");
    printf("Mac address: %02x:%02x:%02x:%02x:%02x:%02x\n\r",gWIZNETINFO.mac[0],gWIZNETINFO.mac[1],gWIZNETINFO.mac[2],gWIZNETINFO.mac[3],gWIZNETINFO.mac[4],gWIZNETINFO.mac[5]);
    printf("IP address : %d.%d.%d.%d\n\r",gWIZNETINFO.ip[0],gWIZNETINFO.ip[1],gWIZNETINFO.ip[2],gWIZNETINFO.ip[3]);
    printf("SM Mask	   : %d.%d.%d.%d\n\r",gWIZNETINFO.sn[0],gWIZNETINFO.sn[1],gWIZNETINFO.sn[2],gWIZNETINFO.sn[3]);
    printf("Gate way   : %d.%d.%d.%d\n\r",gWIZNETINFO.gw[0],gWIZNETINFO.gw[1],gWIZNETINFO.gw[2],gWIZNETINFO.gw[3]);
    printf("DNS Server : %d.%d.%d.%d\n\r",gWIZNETINFO.dns[0],gWIZNETINFO.dns[1],gWIZNETINFO.dns[2],gWIZNETINFO.dns[3]);
}

